<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { useDashboardStore } from '@/stores/dashboard';
import { storeToRefs } from 'pinia';
import { computed, inject } from 'vue';
import FavoriteStar from '@/components/general/FavoriteStar.vue';
import type { dashboardItem } from '@/types/dashboard';
import SelectionCheckbox from '@/components/account/SelectionCheckbox.vue';
import PaneTypeBadge from '@/components/account/PaneTypeBadge.vue';
import Button from '@/components/general/Button.vue';
import { request } from '@/lib/request';
import { useI18n } from 'vue-i18n';
import { handleModeEnum, notificationStatus } from '@/enums/enums';
import { useBaseStore } from '@/stores/base';

const { t } = useI18n();
const $t = t;
let configuration = inject<any>('configuration');
const basePath = configuration.basePath;
const dashboardStore = useDashboardStore();
const baseStore = useBaseStore();
const { selectedItems, favorites, isMoveToFolderModalOpen, folderParent, paneHandleMode, paneId } = storeToRefs(dashboardStore);
const { message, status } = storeToRefs(baseStore);

const props = defineProps<{
    item: dashboardItem
}>();

const emits = defineEmits<{
    (e: 'favorite'): void,
}>();


const handleRemoveFromFavorites = async (id: string) => {
    const response = await request('DELETE', configuration.apiServer + `/api/overview/favorite/${props.item.hash_pane}`, undefined, 'application/json', false, true);
    if (response && response.success) {
        favorites.value = response.favorites;
        message.value = $t('dashboardPage.favorites.delete.message');
        emits('favorite');
    } else {
        console.error("Couldn't be deleted to favorites");
        message.value = "";
        status.value = notificationStatus.DANGER;
        message.value = $t('general.errors.unexpected');
    }
};

const handleAddToFavorites = async (id: string) => {
    const response = await request('POST', configuration.apiServer + `/api/overview/favorite/${props.item.hash_pane}`, undefined, 'application/json', false, true);
    if (response && response.success) {
        favorites.value = response.favorites;
        message.value = $t('dashboardPage.favorites.add.message');
        emits('favorite');
    } else {
        console.error("Couldn't be added to favorites");
        message.value = "";
        status.value = notificationStatus.DANGER;
        message.value = $t('general.errors.unexpected');
    }
};

const handleShowDeleteModal = (show: boolean, id?: string) => {
    if (!show)
        paneId.value = '';
    else if (id) {
        paneId.value = id;
    }
    paneHandleMode.value = handleModeEnum.DELETE;
};

const handleMoveToFolder = (pane: string, folder: string) => {
    isMoveToFolderModalOpen.value = true;
    //paneId.value = hashcode;
    selectedItems.value.push(pane);
    folderParent.value = folder;
}

const getLastUpdate = computed(() => {
    return new Date(props.item.last_update.replace(' ', 'T').split('.')[0]).toLocaleDateString('de-DE', { year: 'numeric', month: 'long', day: 'numeric' });
});

</script>
<template>
    <div class="flex flex-row w-[100px] mt-2 gap-2">
        <div class="mt-1"
            v-if="(item.origin_mail === undefined || item.origin_mail === null) || (item.origin_mail !== undefined && item.origin_mail === item.mail)">
            <SelectionCheckbox :id="item.hash_pane" />
        </div>
        <div class="w-4" v-else></div>
        <div class="w-5 ml-2 mr-2" v-if="item.origin_mail !== undefined && item.origin_mail !== null">
            <FavoriteStar :isFavorite="true" @click="handleRemoveFromFavorites(item.hash_pane)" />
        </div>
        <div class="w-5 ml-2 mr-2" v-else>
            <FavoriteStar :isFavorite="false" @click="handleAddToFavorites(item.hash_pane)" />
        </div>
        <PaneTypeBadge :type="item.type"></PaneTypeBadge>
    </div>
    <div class="line-clamp-1 text-ellipsis align-middle leading-10">
        <Tooltip :tooltip="item.headline">{{ item.headline }}</Tooltip>
    </div>
    <div class="line-clamp-1 text-ellipsis align-middle leading-10">
        <Tooltip :tooltip="item.subheadline">{{ item.subheadline }}</Tooltip>
    </div>
    <div class="text-center align-middle leading-10">{{ getLastUpdate }}
    </div>
    <div class="flex flex-row gap-2 justify-around justify-self-end" v-if="selectedItems.length === 0">
        <Tooltip :tooltip="$t('contentPage.deleteLabel')">
            <button class="text-red-700 hover:text-red-800 bg-white size-8 rounded-full hover:bg-red-100 cursor-pointer"
                @click="handleShowDeleteModal(true, item.hash_pane)"
                v-if="(item.origin_mail === undefined || item.origin_mail === null) || (item.origin_mail !== undefined && item.origin_mail === item.mail)"><i
                    class="ri-delete-bin-line text-[20px]"></i></button>

            <div v-else class="w-8"></div>
        </Tooltip>
        <Tooltip :tooltip="$t('dashboardPage.folder.move.label')">
            <button class="text-blue-800 hover:text-blue-900 bg-white size-8 rounded-full hover:bg-blue-100 cursor-pointer"
                @click="handleMoveToFolder(item.hash_pane, item.folder)"
                v-if="(item.origin_mail === undefined || item.origin_mail === null) || (item.origin_mail !== undefined && item.origin_mail === item.mail)"><i
                    class="ri-folder-2-line text-[20px]"></i></button>
            <div v-else class="w-8"></div>
        </Tooltip>
        <div class="w-fit">
            <Button size="small" variant="accent2" :to="basePath + 'a/' + item.hash_pane">{{
                $t("dashboardPage.buttonPane")
                }}</Button>
        </div>
    </div>
</template>